package edu.neu.ccs.demeterf.demfgen.dgp;

import edu.neu.ccs.demeterf.ID;
import edu.neu.ccs.demeterf.Traversal;
import edu.neu.ccs.demeterf.demfgen.ParseGen;
import edu.neu.ccs.demeterf.demfgen.classes.*;
import edu.neu.ccs.demeterf.demfgen.dgp.traversals.Travs;
import edu.neu.ccs.demeterf.demfgen.Diff;
import edu.neu.ccs.demeterf.lib.*;

/** Pretty Print the structures in CD syntax. */
public class Print extends Concrete{
    public Print(){ this(""); }
    public Print(String beh){ super(beh); }
    public Print functionObj(String beh){ return new Print(beh); }
    public String docComment(){ return "Computes a String representation in CD Syntax"; }
    public String primitive(String p){ return "   public _LT combine("+p+" _h_){ return empty.append(new _S("+wrapStr(p,"_h_")+")); }\n"; }
    
    public List.GComp<TypeUse,TypeDef> genericComp(){
        return TravGeneric.genericByNameOnly();
    }
    /** Use an inlined traversal */
    public Trav realTraversalObj(){
        return Travs.TheFactory.makePrintTrav(this);
    }
    public String combine(Some<List<TypeDef>> some, String s){
        String pre = "";
        String body = 
               ("   static _LT empty = new _LT();\n"+
                "   public "+Diff.d.fieldClassMod+" class _LT{\n" +
                "     edu.neu.ccs.demeterf.lib.List<_T> l;\n"+
                "     public _LT(){ l = new edu.neu.ccs.demeterf.lib.Empty<_T>(); }\n" +
                "     public _LT(edu.neu.ccs.demeterf.lib.List<_T> ll){ l = ll; }\n"+
                "     public _LT push(_T t){ return new _LT(l.push(t)); }\n"+
                "     public _LT append(_T t){ return new _LT(l.append(t)); }\n"+
                "     public _LT append(_LT t){ return new _LT(l.append(t.l)); }\n"+
                "     public String toString(){ return l.fold(new _F(),\"\"); }\n"+
                "     public _LT compress(){ return l.isEmpty()?this:compress(new _E(), l); }\n"+
                "     public static _LT compress(_S s, edu.neu.ccs.demeterf.lib.List<_T> r){\n"+
                "        if(r.isEmpty())return (s.isE())?empty:empty.push(s);\n"+
                "          _T top = r.top();\n"+
                "          if(top.isS())return compress(s.append((_S)top), r.pop());\n"+
                "          if(s.isE())return compress(s, r.pop()).push(top);\n"+
                "          return compress(new _E(), r.pop()).push(top).push(s);\n"+
                "     }\n"+
                "   }\n"+
                "   public"+Diff.d.fieldClassMod+" class _T{\n"+
                "     public "+(Diff.isCS()?"virtual ":"")+Diff.d.equalsRet+" isS(){ return false; }\n"+
                "     public "+(Diff.isCS()?"virtual ":"")+Diff.d.equalsRet+" isE(){ return false; }\n"+
                "   }\n"+
                "   public"+Diff.d.fieldClassMod+" class _P "+Diff.d.inherit+" _T{ public static _P p = new _P(); }\n"+
                "   public"+Diff.d.fieldClassMod+" class _M "+Diff.d.inherit+" _T{ public static _M m = new _M(); }\n"+
                "   public"+Diff.d.fieldClassMod+" class _N "+Diff.d.inherit+" _T{ public static _N n = new _N(); }\n"+
                "   public"+Diff.d.fieldClassMod+" class _R "+Diff.d.inherit+" _T{ public static _R r = new _R(); }\n"+
                "   public"+Diff.d.fieldClassMod+" class _S "+Diff.d.inherit+" _T{\n"+
                (Diff.d.isJava()?
                        "     public StringBuffer s;\n"+
                        "     public _S(String ss){ s = new StringBuffer(ss); }\n":
                            "     public System.Text.StringBuilder s;\n"+
                            "     public _S(String ss){ s = new System.Text.StringBuilder(ss); }\n")+
                "     public _S append(_S ss){ s."+(Diff.d.isCS()?"A":"a")+"ppend(ss.s); return this; }\n"+
                "     public "+Diff.d.override+" "+Diff.d.equalsRet+" isS(){ return true; }\n"+
                "   }\n"+
                "   public"+Diff.d.fieldClassMod+" class _E "+Diff.d.inherit+" _S{\n"+
                "     public _E()"+(Diff.isCS()?":base(\"\")":"")+"{ "+(Diff.isJava()?"super(\"\");":"")+"}\n"+
                "     public "+Diff.d.override+" "+Diff.d.equalsRet+" isS(){ return true; }\n"+
                "   }\n"+
                "   public"+Diff.d.fieldClassMod+" class _F "+Diff.d.inherit+(Diff.isJava()?
                    " edu.neu.ccs.demeterf.lib.List.Fold<_T,String>":
                    " edu.neu.ccs.demeterf.lib.List<_T>.Fold<String>")+"{\n"+
                "     int idt = 0;\n"+
                "     public "+Diff.d.override+" String fold(_T t, String s){\n"+
                "        if(t == _P.p)plus();\n"+
                "        else if(t == _M.m)minus();\n"+
                "        else if(t == _R.r)s += \"\\r\";\n"+
                "        else if(t == _N.n)s += \"\\n\"+indent();\n"+
                "        else s += ((_S)t).s;\n"+
                "        return s;\n"+
                "     }\n"+
                "     void plus(){ idt++; }\n"+
                "     void minus(){ idt--; }\n"+
                "     String indent(){ return indent(idt); }\n"+
                "     static String indent(int i){ return (i <= 0)?\"\":\"   \"+indent(i-1); }\n"+
                "   }\n"+Diff.d.escapeMethods+s);
        return finish(some.inner(), pre, body);
    }
    
    static class FN extends Syntax{
        String id; FN(String i){ id = i; }
        public String toString(){ return id; }
    }
    public Syntax combine(Syntax t){ return t; }
    public Syntax combine(Field f, ident id, TypeUse t){ return new FN(""+id);}
    public String combine(ClassDef td, DoGen g, ident n, TypeDefParams dp, List<String> sts, List<Syntax> bdy){
        if(sts.length() > 0)return "";
        List.Pred<Syntax> p = new List.Pred<Syntax>(){
            public boolean huh(Syntax s){ return s instanceof FN; }
        };
        List<Syntax> fields = bdy.filter(p);
        return ("   public _LT combine("+argType(n,dp)+" _h_"+fields.toString("",", _LT ")+"){\n"+
                "      return empty"+fold(bdy)+(bdy.isEmpty()?"":".compress()")+";\n"+
                "   }\n");
    }
    static String fold(List<Syntax> bdy){
        return new Traversal(new ID(){
            String a = ".append("; 
            String combine(AddToken t, String s){ return a+"new _S(\""+ParseGen.escape(s)+"\"))"; }
            String combine(AddSpace s){ return a+"new _S(\" \"))"; }
            String combine(AddTab t){ return a+"new _S(\"    \"))"; }
            String combine(Plus t){ return a+"_P.p)"; }
            String combine(Minus t){ return a+"_M.m)"; }
            String combine(AddLine t){ return a+"_N.n)"; }
            String combine(AddReturn t){ return a+"_R.r)"; }
            String combine(FN t, String n){ return a+n+")"; }
            String combine(TheEOF t){ return ""; }
            String combine(Empty<Syntax> e){ return ""; }
            String combine(Cons<Syntax> c, String f, String r){ return f+r; }
        }).traverse(bdy);
    }
    public String stubMethodBody(){
        return ("return new edu.neu.ccs.demeterf.Traversal(new "+
                fileName()+"(),edu.neu.ccs.demeterf.Control.builtins("+wrap(builtins())+"))."+
                Diff.d.paramMethod("traverse",this.getClass().getSimpleName()+
                        "._LT")+"(o).toString();");
    }
}
